'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _object = require('object.assign');

var _object2 = _interopRequireDefault(_object);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _style = require('./style');

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Box = function (_PureComponent) {
  _inherits(Box, _PureComponent);

  function Box() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Box);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Box.__proto__ || Object.getPrototypeOf(Box)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      collapsed: _this.props.collapsible ? !!_this.props.defaultCollapsed : false
    }, _this.toggleContent = function () {
      _this.setState({ collapsed: !_this.state.collapsed });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Box, [{
    key: 'render',
    value: function () {
      function render() {
        var _props = this.props,
            children = _props.children,
            config = _props.config,
            _props$overflow = _props.overflow,
            overflow = _props$overflow === undefined ? true : _props$overflow,
            boxShadow = _props.boxShadow,
            headingText = _props.headingText,
            headingIcon = _props.headingIcon,
            headingType = _props.headingType,
            defaultCollapsed = _props.defaultCollapsed,
            collapsible = _props.collapsible,
            props = _objectWithoutProperties(_props, ['children', 'config', 'overflow', 'boxShadow', 'headingText', 'headingIcon', 'headingType', 'defaultCollapsed', 'collapsible']);

        var Heading = headingType || 'h2';
        var isBoxShadowEnabled = typeof boxShadow === 'boolean' ? boxShadow : config.boxShadow;
        var boxStyles = (0, _object2['default'])({}, _style2['default'].box, {
          backgroundColor: config.boxBg,
          boxShadow: isBoxShadowEnabled ? '0 0 3px rgba(0,0,0,0.4)' : '',
          overflow: overflow ? 'hidden' : 'initial'
        });

        var headingProps = {
          style: _style2['default'].heading
        };

        if (collapsible) {
          headingProps.style = (0, _object2['default'])({}, headingProps.style, _style2['default'].headingCollapsible);

          headingProps.onClick = this.toggleContent;
        }

        return _react2['default'].createElement(
          'div',
          _extends({}, props, { style: boxStyles }),
          headingText && _react2['default'].createElement(
            Heading,
            headingProps,
            headingIcon && _react2['default'].createElement(_Icon2['default'], { type: headingIcon, style: _style2['default'].headingIcon }),
            _react2['default'].createElement(
              'span',
              { style: _style2['default'].headingText },
              headingText
            ),
            collapsible && _react2['default'].createElement(_Icon2['default'], { type: this.state.collapsed ? 'FaAngleDown' : 'FaAngleUp' })
          ),
          !this.state.collapsed && _react2['default'].createElement(
            'div',
            null,
            children
          )
        );
      }

      return render;
    }()
  }]);

  return Box;
}(_react.PureComponent);

exports['default'] = Box;